<script lang="ts">
  export let score: number;

  let previousScore = score;

  let deltas: Array<{ key: string; value: number }>;
  $: deltas = [];

  $: if (score !== previousScore) {
    deltas = [{ value: score - previousScore, key: Math.random().toString() }];
    previousScore = score;
  }
</script>

<div class="wrapper">
  <div class="emoji">⭐</div>
  <div class="score">{score}</div>

  {#each deltas as { key, value } (key)}
    <div class="delta" class:positive={value > 0} class:negative={value < 0}>
      {value > 0 ? "+" : "−"}{Math.abs(value)}
    </div>
  {/each}
</div>

<style>
  .wrapper {
    position: relative;
  }
  .emoji {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%) translateY(-2.5%);
    font-size: 150%;
    filter: drop-shadow(0 0 1px black);
  }
  .score {
    color: white;
    filter: drop-shadow(0 0 1px black);
    font-weight: bold;
  }

  @keyframes fade-up {
    from {
      opacity: 50%;
      transform: translate(-50%, -50%);
    }
    50% {
      opacity: 100%;
      transform: translate(-50%, -150%);
    }
    to {
      opacity: 0%;
      transform: translate(-50%, -150%);
    }
  }
  .delta {
    opacity: 0;
    top: 50%;
    left: 50%;
    position: absolute;
    animation: 1.5s normal fade-up;

    font-weight: bold;
    filter: drop-shadow(0 0 1px black);
  }
  .delta.positive {
    color: lightgreen;
  }
  .delta.negative {
    color: pink;
  }
</style>
